/*
COMMENTI:
ATTENZIONE: questa versione lavora con bande upl e dwnl uguali
se cio' dovesse cambiare, siccome il T_RATE viene modificato in base all'upload bw, 
bisogna tener conto di cio', soprattutto quando si fanno diversi "turn"

utilizzo:
digita il file eseguibile senza parametri e leggi le istruzioni 


ho compattato nella struttura Node molte informazioni
- il vecchio base_vector e' diventato .level
- le bande sono assegnate direttamente
- il vettore fathers e' inglobato 
- la matrice dei neighbor, inglobata

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#define DEFAULT_SEED  (long) 14123451
#define MAX(a, b) ((a) > (b) ? (a) : (b))
#define MIN(a, b) ((a) < (b) ? (a) : (b))

#define MAX_CHILDREN  20
#define MIN_PERCENTAGE_USED_BW  0.75

#define NUM_PEERS 0
#define END_FILE  1
#define END_CHUNK 2
#define NUM_LEAVES 3

#define NUM_STRIPES 2

/* funzioni di supporto */
#define MODULE  2147483647
#define A       16807
#define LASTXN  127773
#define UPTOMOD -2836
#define RATIO   0.46566128e-9            /* 1/MODULE */


/* this global variable is used to read the input file and store the input pdf */
double **base_chunk_vect;  

typedef struct node_unit
{
  int    level;        /* it stores the number of level in the diffusion tree */
  double dwl_bw;       /* the download bandwidth of the node */
  double upl_bw;       /* the upload bandwidth of the node */
  double rate;         /* the actual rate used to transfer chunks*/
  double end_chunk;    /* the instant when the first chunk is completely downloaded */
  double end_file;     /* the instant when the whole file is completely downloaded */
  int    num_children; /* number of children the node has */
  double spare_dwl_bw; /* actual spare download bandwidth */
  double spare_upl_bw; /* actual spare upload bandwidth */
  double new_rate;     /* additional rate gained in different rounds */
  int    fathers;      /* number of fathers to download from */
  int    stripe;       /* id of the stripes that have being downloaded */
  int   *neighbors;    /* pointer to the list of neighbors */ 
}
Node;



/*        
**  Function  : long rnd32(long seed) 
**  Return    : the updated value of 'seed'.
**  Remarks   : congruential generator of pseudorandom sequences of numbers
**              uniformly distributed between 1 and 2147483646, using the 
**              congruential relation: Xn+1 = 16807 * Xn  mod  2147483647 . 
**              The input to the routine is the integer Xn, while the returned 
**              integer is the number Xn+1.
*/
long rnd32(long seed)
{
 long times, rest, prod1, prod2;

 times = seed / LASTXN;
 rest  = seed - times * LASTXN;
 prod1 = times * UPTOMOD;
 prod2 = rest * A;
 seed  = prod1 + prod2;
 if(seed < 0) seed = seed + MODULE;
 return seed;
}


/*
**  Function  : double uniform_0_1(long *seed)
**  Return    : a value uniformly distributed between 0 and 1
**  Remarks   : the value of '*seed' is changed.
*/        
double uniform_0_1(long *seed)
{
 double u;
 *seed = rnd32 (*seed);
 u = (*seed) * RATIO;
 return u;
}

/*
**  Function  : double uniform(double a, double b, long *seed)
**  Return    : a value uniformly distributed between 'a' and 'b'
**  Remarks   : the value of '*seed' is changed.
*/        
double uniform(double a, double b, long *seed)
{
 double u;
 *seed = rnd32 (*seed);
 u = (*seed) * RATIO;
 u = a + u * (b-a);
 return u;
}

/*
**  Function  : int read_input(char *)
**  Return    : number of deltas that composes the distribution
**  Remarks   : it opens input "filename" and reads line by line;  
**
*/
int read_input(char *filename)
{

 FILE *fptr;
 char buffer[255], value_t[50], value_t2[50], value_p[50];
 int i, j, k, read_param, output;
 double cumulative;

///////////////////////////////////////
output = 0;
///////////////////////////////////////
 
   
 if((fptr = fopen(filename, "r")) == NULL)
    {                                           /* no correspondance to an */
     printf("File %s not found\n", filename);   /* existing file: the   */
     exit(1);                                   /* program execution is */ 
    }                                           /* immediately ended.   */
    
//conto quante linee ci sono, ovvero quante delta compongono la pmf
 while(fgets(buffer, 255, fptr) != NULL)
   {
     read_param = sscanf(buffer, "%s %s %s", value_t, value_t2, value_p);
     if(read_param != 3)
        {  printf("File format is not correct\n"); 
           exit(1);
        }
     output++;
   }//while
   
/* output contiene il numero di delta: ora posso crare il vettore base_chunk_vect;
   base_chunk_vect e' una matrice con due righe; quella sotto ha le bande, quella sopra le prob*/
  base_chunk_vect = malloc(3*sizeof(double*));
  for(k = 0; k < 3; k++){
       base_chunk_vect[k] = malloc(output*sizeof(double));
     }//for k     
  // initialize it
  for (i=0; i<3; i++){
     for (j=0; j<output; j++){
          base_chunk_vect[i][j] = 0.0;
         }//for j
     }//for i
      
// faccio il rewind del file
 rewind(fptr);
 output = 0;

// ora lo rileggo memorizzando i dati 
 while(fgets(buffer, 255, fptr) != NULL)
   {
     read_param = sscanf(buffer, "%s %s %s", value_t, value_t2, value_p);
     base_chunk_vect[0][output] = atof(value_p);
     base_chunk_vect[1][output] = atof(value_t);   // download
     base_chunk_vect[2][output] = atof(value_t2);  // upload
     output++;
   } /* while ... */
 
 fclose(fptr);

/* creazione della cumulativa */
 cumulative = 0.0;
 for (i=0; i<output; i++){
     cumulative += base_chunk_vect[0][i];
     base_chunk_vect[0][i] = cumulative;
     }//for i
             
return(output);
}

/*
**  Function  : void shuffle(int dimesione, int *input)
**  Return    : perform a permutation of the element of vector "input"
*/        
void shuffle(int dimesion, int *input, long *seed){

 int i, rnd_int, dummy;
 
 for (i=0; i < dimesion-1; i++){
     rnd_int = (int)uniform(0.0, (double)(dimesion-i), seed);
     dummy = input[i];
     input[i] = input[i+rnd_int]; 
     input[i+rnd_int] = dummy;
 }  
}

/*    
      FUNCTION:       swaps two elements in a vector (of doubles); used in quicksort
      INPUT:          two arrays, positions to be swapped
      OUTPUT:         none
*/
void swap(double *v, int i, int j)
{
  double tmp;

  tmp = v[i];
  v[i] = v[j];
  v[j] = tmp;
}

/*    
      FUNCTION:       swaps two elements in a vector (of int);
      INPUT:          two arrays, positions to be swapped
      OUTPUT:         none
*/
void swap_int(int *v, int i, int j)
{
  int tmp;

  tmp = v[i];
  v[i] = v[j];
  v[j] = tmp;
}

/*    
      FUNCTION:       swaps two elements in a vector and a second vector; used in quicksort
      INPUT:          two arrays, positions to be swapped
      OUTPUT:         none
*/
void swap_int_2_vectors(int *v, int i, int j, int *v2)
{
  int tmp;

  tmp = v[i];
  v[i] = v[j];
  v[j] = tmp;
  tmp = v2[i];
  v2[i] = v2[j];
  v2[j] = tmp;
  
}


/*    
      FUNCTION:       implementation of quicksort; second index vector is updated, too
      INPUT:          two arrays, left and right delimiter
      OUTPUT:         none
*/
void sort(double *v, int left, int right)
{
  int k, last;

  if (left >= right) 
    return;
  swap(v, left, (left + right)/2);
  last = left;
  for (k=left+1; k <= right; k++)
    if (v[k] < v[left])
      swap(v, ++last, k);
  swap(v, left, last);
  sort(v, left, last);
  sort(v, last+1, right);
}


/*    
      FUNCTION:       implementation of quicksort (with integers)
      INPUT:          two arrays, left and right delimiter
      OUTPUT:         none
*/
void sort_int(int *v, int left, int right)
{
  int k, last;

  if (left >= right) 
    return;
  swap_int(v, left, (left + right)/2);
  last = left;
  for (k=left+1; k <= right; k++)
    if (v[k] < v[left])
      swap_int(v, ++last, k);
  swap_int(v, left, last);
  sort_int(v, left, last);
  sort_int(v, last+1, right);
}


/*    
      FUNCTION:       implementation of quicksort; second index vector is updated, too
      INPUT:          two arrays, left and right delimiter
      OUTPUT:         none
*/
void sort_int_2_vectors(int *v, int left, int right, int *v2)
{
  int k, last;

  if (left >= right) 
    return;
  swap_int_2_vectors(v, left, (left + right)/2, v2);
  last = left;
  for (k=left+1; k <= right; k++)
    if (v[k] < v[left])
      swap_int_2_vectors(v, ++last, k, v2);
  swap_int_2_vectors(v, left, last, v2);
  sort_int_2_vectors(v, left, last, v2);
  sort_int_2_vectors(v, last+1, right, v2);
}


/*
**  Function  : max_min_fairness_allocation()
**  Return    : change the values of b_allocated
**  Remarks   : 
*/        
void max_min_fairness_allocation(int num_children, double b_father, double *b_children_vect, 
                                   double *b_allocated, int *b_notcompl)
{
 double sum_spare;
 int    sum_notcompl, i, r;
 
     for (i=0; i<num_children; i++){
           b_allocated[i] = 0.0; 
           b_notcompl[i] = 1; 
      }//for i 
      sum_notcompl = num_children;
          while(sum_notcompl>0) {   
                sum_spare = 0;
                for (r=0; r<num_children; r++){
                    if(b_notcompl[r] == 1){    
                       b_allocated[r] += b_father/sum_notcompl;    
                       }//if
                    if(b_allocated[r] > b_children_vect[r]){
                       b_notcompl[r] = 0;
                       sum_spare += b_allocated[r] - b_children_vect[r];
                       b_allocated[r] = b_children_vect[r];    
                       }//if
                }//for r
                if(sum_spare > 0){
                   b_father = sum_spare;
                   sum_notcompl = 0;
                   for (r=0; r<num_children; r++){
                       sum_notcompl += b_notcompl[r];
                   }//for r
                }//if
                else { sum_notcompl = 0; }    
            }//while   
}

/**********************************************************************/
/**********************************************************************/
/**                                                                  **/
/**                              MAIN                                **/
/**                                                                  **/
/**********************************************************************/
/**********************************************************************/

int main(int argc, char *argv[]){

 /* system description */
 Node *node_list;        /* pointer to the list of the structure that contains node information */
 int num_neighbors,      /* maximum number of neighbors a node can have */
     max_num_peers,      /* maximum number of peers in the network */ 
     max_chunk_transfer_time,  /* used only at the beginning to store a particular value of the pdf*/
     time_limit_for_chunk,     /* maximum limit of the t_reach */
     time_limit_for_file,      /* maximum limit of t_dwnl, used for the hitogram */
     expansion_factor,         /* how much the time_vector must be expanded in order to be able 
                                  to store all the events managing the overlapping ones */
     MAX_LEVELS,         /* define maximum nmber of level admitted for the tree */
     chunks,             /* num di chunk */
     num_deltas_pmf,     /* how many deltas are in the input pdf, i.e., how many classes */ 
     max_iterations,     /* number of iterations/sample of the markov process */ 
     max_num_children,   /* maximum outdegree */
     min_num_children,   /* minimum outdegree */
     bw_normalization,   /* used from bw to times, so that the maximum bandowdth becomes the maximum time*/
     max_rounds;         /* maximum number of rounds allowed */
 int *neighbors_id_basic;
 double MAX_EXP,       /* define the exponent such that the number of peers are 10^MAX_EXP */
        p_selfish;     /* probability to have a selfish peer that does not upload ot other nodes */  
     
 /* system status */    
 long seed;
 int *time_vector,       /* is the vector that stores the peer_id at different times: 
                            pratically, an event scheduler*/ 
     *x_round_id_list;    /* list of the nodes selected for the multiple rounds */
 
 int reached_peers,      /* keeps track of the number of reached peer in the actual realization */
     actual_levels,      /* stores temporarily the level of the node in the tree */
     time_index,         /* index used to read the time_vetor, that is the main vector that manages the events */
     aux_time_index,     /* same as previuos index, used when we need another reference point*/
     not_overflow,       /* boolean variable that control we stay withini time_index bound */
     peer_id,            /* used to register the peer_id instead of looking always at the time_vector */
     neighbor_id,        /* used to register the neighbor_id instead of looking always at the node list */
     iterations,         /* it counts the number of current iterations (how many trees are built) */
     num_children,       /* actual number of children  */
     rounds,             /* it counts the number of current rounds */
     num_peers_this_round, /* auxiliary variable used in the round management */
     num_peers_next_round, /* auxiliary variable used in the round management */
     offset_this_round,    /* auxiliary variable used in the round management */
     neighbor_rcv_stripe,  /* id of the stripe of the node */
     father_stripe;        /* id of the stripe of the father */
 double b_father,        /* bw of the father node, used when it selects its children */
        b_father_transm, /* when the father is selecting its children, it register the actual rate used */
        b_children_tot,  /* when the father is selecting its children, it register their total bw */
        b_children_transm, /* it register the actual total rate used by children */ 
        used_bandwidth,    /* auxiliary parameter used in the process of children selection */ 
        extracted_dwl_bw, /* auxiliary parameter used to memorize dwl bw of the nodes */ 
        extracted_upl_bw;  /* auxiliary parameter used to memorize upl bw of the nodes */
 
 int     *b_notcompl,        /* auxiliary vector used in the bw allocation process */
         *b_children_id;     /* it registers the id of the first-generation children */
 double  *b_children_vect,   /* auxiliary vector used in the bw allocation process: dwl bw of the children */
         *b_children_vect_u, /* auxiliary vector used in the bw allocation process: upl bw of the children */ 
         *b_allocated;       /* auxiliary vector used in the bw allocation process: rate allocated */

     
 /* statistics */
 int num_samples;        /* number of samples taken at the end to display results */
 double **end_file_time,    /* matrix that stores, for each round, the download time of each node */ 
        **end_file_samples, /* a sample of the previuos matrix */
         *num_leaves,       /* structure that register the number of leaves for each bandwidth class */ 
         *spare_bw,         /* structure that register the spare bandwidth for each round */
        **reached_peers_per_level,       /* stores statistics when analyze the system from a level viewpoint */
        **reached_peers_per_level_final, /* same as before, analyzing the whole iterations */
          *histogram_node_50;            /* store the histogram of the download times of the node with id = 50 */
 
 /* time variables */
 clock_t  start_CPU_time;        /* CPU time elapsed at the beginning of */
                                /* the main simulation cycle.           */
 clock_t  end_CPU_time;          /* CPU time elapsed at the end of the   */
                                /* simulation run.                      */
 
 /* auxiliary variables */
 FILE *fout;
 char *namefilein, namefileout[80], namefileout2[80], out_file_radix[80];
 int i, j, k, dummy, aux_index, non_null_elem;
 double cumulative_peers, cumulative_peers2, rnd_value, tmp, prev_value, prev_bw, total_bw;

 
 
 
/******************************************************************/
/*  leggo la riga di input e carico i parametri                   */
/******************************************************************/
         
if(argc!=12) {
printf("\nutilizzo => ./exe p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11\n");
printf("dove: p1 = nome file input\n");
printf("      p2 = nome file output\n");
printf("      p3 = # max_iterations(accuracy)\n");
printf("      p4 = max numero di vicini\n");
printf("      p5 = max numero di livelli dell'albero\n");
printf("      p6 = # min di figli\n");
printf("      p7 = # max di figli\n");
printf("      p8 = # alberi ptree\n");
printf("      p9 = # chunks\n");
printf("      p10= exp in #peers = 10^(exp)\n");
printf("      p11 = probabilita' di nodo shelfish (ad es. 0.05)\n");
exit(0);
}

 namefilein        = argv[1];
 strcpy(out_file_radix, argv[2]);
 
 max_iterations    = atoi(argv[3]);
 num_neighbors     = atoi(argv[4]);
 MAX_LEVELS        = atoi(argv[5]);
 min_num_children  = atoi(argv[6]);
 max_num_children  = atoi(argv[7]);
// num_ptrees        = atoi(argv[8]);
 max_rounds        = atoi(argv[8]);
 chunks            = atoi(argv[9]);
 MAX_EXP           = atof(argv[10]); //esponente da dare a 10 per ottenere il 
                                     // numero di peer per la simulazione
 p_selfish         = atof(argv[11]);
 
 
/* Obtaining the CPU time elapsed at the beginning of the main          */
/* simulation cycle.                                                    */
 start_CPU_time = clock(); 

/* carico il file di input che contiene la pmf (delle bande); come risultato mi da' 
   anche il numero di delta che compongono tale pmf;
   ATTENZIONE: base_chunk_vect contiene gia' la cumulativa */

num_deltas_pmf = read_input(namefilein);

/*  bw_normalization contiene il fattore che normalizza il valore delle bande in 
    modo tale che il la matrice che contiene le distribuzioni finali sia
    sufficientemente ampia; i valori vengono scelti tra la banda di download */
bw_normalization = base_chunk_vect[1][0]*base_chunk_vect[1][num_deltas_pmf-1];


/******************************************************************/
/*  assegno alcuni parametri base                                 */
/******************************************************************/
 
seed = DEFAULT_SEED;

max_num_peers = (int)pow(10.0, MAX_EXP);
//max_num_peers = 20;
expansion_factor = MAX(max_num_peers/100, 1);
/* come tempo massimo per il trasferimento del singolo chunk prendo
   la banda piu' alta: con il fattore di normalizzazione, infatti, questo corrisponde
   al tempo di trasferimento di un chunk */
max_chunk_transfer_time = base_chunk_vect[1][num_deltas_pmf-1];
/* nel calcolare time_limit_for_chunk uso expansion_factor definito nel #define sopra e moltiplico
   per 2 per sicurezza*/
time_limit_for_chunk = max_chunk_transfer_time * MAX_LEVELS * expansion_factor; 

// creazione del vettore che contiene l'ordine di analisi dei peer 
time_vector = malloc(time_limit_for_chunk*sizeof(int)); 
//inizializzazione
for (i=0; i < time_limit_for_chunk; i++){
   time_vector[i] = -1; //negativo perche' l'indice 0 e' un peer
}//for i 


/******************************************************************/
/*  creation of structures                                        */
/******************************************************************/

/* Here we create the vector of Node objects */
node_list = malloc(max_num_peers*sizeof(Node));

/* This is a list used for storing the order of the nodes rounds after rounds */
x_round_id_list    = malloc(max_num_peers*sizeof(int));

/* this vector is used in case of uniform generation of the neighbors */
neighbors_id_basic = malloc(num_neighbors*sizeof(int)); 
/* value (determinitic) assignment */ 
for (i=0; i < (num_neighbors/2); i++){
    dummy  = (int)pow(2, (i*2*8*sizeof(int)/(double)num_neighbors)); 
    neighbors_id_basic[2*i]   = dummy%max_num_peers;  
    neighbors_id_basic[2*i+1] = -(dummy%max_num_peers);  
}


/* We initialize many things */
for (i=0; i < max_num_peers; i++){
  node_list[i].level        = -1;
  node_list[i].dwl_bw       = 0.0;
  node_list[i].upl_bw       = 0.0;
  node_list[i].rate         = 0.0;
  node_list[i].end_chunk    = 0.0;
  node_list[i].end_file     = 0.0;
  node_list[i].num_children = 0;
  node_list[i].spare_dwl_bw = 0.0;
  node_list[i].spare_upl_bw = 0.0;
  node_list[i].new_rate     = 0.0;
  node_list[i].fathers      = 0;  
  node_list[i].stripe       = 0;
  node_list[i].neighbors    = malloc(num_neighbors*sizeof(int));

  /* neighbors assignment */
  for (j=0; j < num_neighbors; j++){
         node_list[i].neighbors[j] = (i + max_num_peers + neighbors_id_basic[j])%max_num_peers;
    }//for j
  /* after populating the list, we shuffle the content, i.e., we introduce randomness */  
  shuffle(num_neighbors, node_list[i].neighbors, &seed);

  /* bandwidth assignation */
  rnd_value = uniform_0_1(&seed);
  extracted_dwl_bw = base_chunk_vect[1][0];
  extracted_upl_bw = base_chunk_vect[2][0];
  for (j=0; j<num_deltas_pmf-1; j++){
       if (rnd_value > base_chunk_vect[0][j]){
           extracted_dwl_bw = base_chunk_vect[1][j+1];
           extracted_upl_bw = base_chunk_vect[2][j+1];
           }//if
      }//for i
      
  node_list[i].dwl_bw = extracted_dwl_bw/bw_normalization;
  node_list[i].upl_bw = extracted_upl_bw/bw_normalization; 
  
  
  /* other initializations */ 
  x_round_id_list[i]  = -1;

}//for i


/* We create a vector that will contain also the end file times for all nodes: 
  it is necessary for the final sorting. 
  We keep track of all the rounds, so we use a matrix*/
end_file_time = malloc(max_rounds*sizeof(double*));
for(k = 0; k < max_rounds; k++){
    end_file_time[k] = malloc(max_num_peers*sizeof(double));
   }//for k     
/* We initialize it */
for (i=0; i < max_rounds; i++){
    for (j=0; j < max_num_peers; j++){
         end_file_time[i][j] = 0.0;
    }//for j
}//for i

/* In this structure we put 200 samples of the end file times; 
   we record the number of i-th reached node and for each round 
   a couple of parameter: the end file time and the number of 
   taken samples */
if(max_num_peers < 200) num_samples = max_num_peers;   
else num_samples = 200;
end_file_samples = malloc(num_samples*sizeof(double*));
for(k = 0; k < num_samples; k++){
    end_file_samples[k] = malloc((2*max_rounds + 1)*sizeof(double));
   }//for k     
/* We initialize it */
dummy = (int)( ((double)max_num_peers) / ((double)num_samples) + 0.5);
for (i = 0; i < num_samples; i++){
    end_file_samples[num_samples - 1 - i][0] = max_num_peers - i*dummy - 1;
    for (j = 1; j < (2*max_rounds); j++){
    end_file_samples[num_samples - 1 - i][j] = 0.0;
    }//for j
}//for i

// creazione del vettore che tiene conto del numero di peer raggiunti al peer 
reached_peers_per_level = malloc(MAX_LEVELS*sizeof(double*)); 
reached_peers_per_level_final = malloc(MAX_LEVELS*sizeof(double*)); 
for(i = 0; i < MAX_LEVELS; i++){
    reached_peers_per_level[i] = malloc(4*sizeof(double));
    reached_peers_per_level_final[i] = malloc(4*sizeof(double));
   }//for i     
// initialize it
for (i=0; i < MAX_LEVELS; i++){
    for (j=0; j < 4; j++){
         reached_peers_per_level[i][j] = 0.0;
         reached_peers_per_level_final[i][j] = 0.0;
    }//for j
}//for i

/* a simple vector that take memory of spare bandwidth for each round */
spare_bw = malloc((max_rounds)*sizeof(double)); 
// initialize it
for (i=0; i < max_rounds; i++){
         spare_bw[i] = 0.0;
}//for i

/********************************************************************/
/* all the following variable are used when a node start picking 
   children until it is saturated */
b_children_vect    = malloc((max_num_children)*sizeof(double));
b_children_vect_u  = malloc((max_num_children)*sizeof(double));
b_allocated        = malloc((max_num_children)*sizeof(double));
b_notcompl         = malloc((max_num_children)*sizeof(int));
for (i=0; i<(max_num_children); i++){
     b_children_vect[i]    = 0.0;
     b_children_vect_u[i]  = 0.0;
     b_allocated[i]        = 0.0;
     b_notcompl[i]         = 0;
}//for i

/********************************************************************/
/* a structure, used only at the beginning, necessary to keep track of 
  id of the first-generation children */
b_children_id  = malloc(NUM_STRIPES*sizeof(int));
for (i=0; i<NUM_STRIPES; i++){
     b_children_id[i]      = 0;
}//for i

/* This structure is used to record the histogram of a single node;
   since at each round the node with id 50 can change bandwidth, we can
   add other histogram measurement, fixining a bw, for instance
*/
time_limit_for_file = max_chunk_transfer_time * (MAX_LEVELS + chunks) * max_num_children;
histogram_node_50 = malloc(time_limit_for_file*sizeof(double)); 
//inizializzazione
for (i=0; i < time_limit_for_file; i++){
   histogram_node_50[i] = 0.0;
}//for i 


/* this structure records how many nodes, for each bandwidth value, are leaves.
   The number of classes is equal to the number of deltas in the pdf (or pmf, 
   if you prefer), so out vector has dimension equal to the number of classes and
   for each class it will record the number of leaves
*/
num_leaves = malloc(num_deltas_pmf*sizeof(double)); 
//inizializzazione
for (i=0; i <num_deltas_pmf; i++){
   num_leaves[i] = 0.0; 
}//for i 


/* other initializations */
tmp = 0; /* this variable is set only to avoid warnigs; it is used only for debug */
num_peers_next_round = 0;
num_peers_this_round = 0;
offset_this_round = 0;

/********************************************************************/
/********************************************************************/
/* now all the variables are allocated and initialized, then we can 
   proceed creating the trees                                       */
/********************************************************************/
/********************************************************************/

/* main cycle: iterations; 
           - it creates max_iteration number of trees
           - it makes the necessary measurements
           - it re-initialize the values
*/
for (iterations = 0; iterations < max_iterations; iterations++){
rounds = 0;
 
   //the server is fast, by definition
   b_father = base_chunk_vect[1][num_deltas_pmf-1];  
  
   //then, extract NUM_STRIPES children
   for (i = 0; i < NUM_STRIPES; i++){
        /* extract a random fast peer: we start from a random point and 
           then pass through the node_list until a fast node 
           (not yet selected) is reached */ 
        peer_id = (int)uniform(0.0, (double)max_num_peers, &seed);
        while( ((int)(bw_normalization*node_list[peer_id].dwl_bw) != (int)b_father) ||
                                      (node_list[peer_id].level   >= 0) ) 
             {peer_id = (peer_id+1)%max_num_peers;} /* the modulo is used to manage the 
                                                       wrap of node list*/
        /*once a fast node is found, we set its level to 1 (level 0 is the server) */ 
         node_list[peer_id].level = 1;  

        /* we register here the bandwidth and the node_id */  
         b_children_vect[i]    = node_list[peer_id].dwl_bw;    
         b_children_vect_u[i]  = node_list[peer_id].upl_bw;
         b_children_id[i]      = peer_id; 
     }

    /* we normalize here the bw of the father (not done before because it was necessary 
       for the comparison done in the previuos for-cycle) */ 
    b_father /= bw_normalization;  
    
    /* decide the rate to give to each children according to max-min criterion */
    max_min_fairness_allocation(NUM_STRIPES, b_father, b_children_vect, b_allocated, b_notcompl);   
   
    /* assign the rate decided */
    for (i = 0; i < NUM_STRIPES; i++){
         
         peer_id = b_children_id[i];
   
         node_list[peer_id].rate         = b_allocated[i];
         node_list[peer_id].end_chunk    = 1/b_allocated[i];
         node_list[peer_id].end_file     = chunks/b_allocated[i];
         node_list[peer_id].spare_dwl_bw = b_children_vect[i] - b_allocated[i];  
         node_list[peer_id].fathers      = 1;  
         node_list[peer_id].stripe       = pow(2,i) + pow(2, 16+i);
 
         /* update here the file time matrix; the result is propagate for all the rounds 
            for computational stability */ 
         for (k=rounds; k < max_rounds; k++){
             end_file_time[k][peer_id] = node_list[peer_id].end_file;
          }
 
         /* since the upload rate is determined not only by the upload rate but also by the
            upload bandwidth, at this stage we need to explicitly take into account this 
            fact; we do this at this stage because it influeces the children of this node, 
            and we use it to compute its download times */
         node_list[peer_id].rate = MIN(node_list[peer_id].rate, 
                                       node_list[peer_id].upl_bw);
         
         /* now we can insert the event in the time_vector that keeps track of the node_id;
            we eapand the index used to insert int he vecotr so we can mange overlapped events */ 
         time_index = expansion_factor*node_list[peer_id].end_chunk;
         while(time_vector[time_index]>=0)
              {time_index++;}
         time_vector[time_index] = peer_id;

      } // for i
   
   /* once the first generation children are created and there event positioned, we can start
      looking at the events; each node will generate the events associated to its children and 
      so on */
      
  not_overflow     = 1;
  time_index       = -1;   
  cumulative_peers = 0;
  actual_levels    = 1;
  reached_peers    = 0;

  while ((reached_peers < max_num_peers) && (actual_levels < MAX_LEVELS) && 
         (time_index < time_limit_for_chunk-1) && (not_overflow)){
        
      time_index++; /* start to analyze the vector */ 
      peer_id = time_vector[time_index];       
      //per ragioni legate al conteggio delle foglie e nodi interni, devo imporre questa condizione qui
//      num_children      = 0;
//      b_children_transm = 0.0;
      
      /* start to analyze the peer, if a peer was scheduled, if MAX_LAVEL is not reached */       
      if((peer_id >= 0)&&(node_list[peer_id].level < MAX_LEVELS-1)) {
         
         /* check if the peer is selfish */ 
         rnd_value = uniform_0_1(&seed);
         if (rnd_value < p_selfish) {continue;}  
         
         /* if not selfish, start the children selection process */
         b_father          = node_list[peer_id].upl_bw;
         b_father_transm   = node_list[peer_id].rate;
         b_children_tot    = 0.0;
         b_children_transm = 0.0;
         num_children      = 0;
         aux_index         = 0;
         actual_levels     = node_list[peer_id].level + 1; /* children will be on the next tree level */
      
         while (((b_children_tot < b_father)||(b_children_transm < b_father)||
                 (num_children<min_num_children))&&(num_children<max_num_children)&& 
                 (aux_index < num_neighbors)) {
              /* check if the next neighbor in yur list is available*/ 
              neighbor_id = node_list[peer_id].neighbors[aux_index];      
              if (node_list[neighbor_id].level < 0) {
                /* register the bw of the neighbor*/    
                extracted_dwl_bw = node_list[neighbor_id].dwl_bw;    
                extracted_upl_bw  = node_list[neighbor_id].upl_bw;    
                
                b_children_vect[num_children]   = extracted_dwl_bw;
                b_children_vect_u[num_children] = extracted_upl_bw;
                
               /* if the neighbor is selected as a child, we swap it and put in first positions:
                  in this way, the first num_children neighbors becomes my children*/
                if (aux_index > num_children){
                    swap_int(node_list[peer_id].neighbors, num_children, aux_index);
                }
                
                b_children_tot += extracted_dwl_bw;
                b_children_transm += MIN(extracted_dwl_bw, b_father_transm);
                /* if (b_children_transm > b_father) I have to check the the father bw is sufficiently
                   used without this new children (a new children will lower the total rate). If father
                   bw is used more than 75%, then I do not add new children */
                if (b_children_transm > b_father){
                    used_bandwidth = b_children_transm - MIN(extracted_dwl_bw, b_father_transm);
                   if ((used_bandwidth/b_father<MIN_PERCENTAGE_USED_BW)||(num_children<min_num_children))
                       {num_children++;
                        /* if the neighbor is added, then we set its level, so it is blocked */       
                        node_list[neighbor_id].level = actual_levels;}
                } 
                else {num_children++;
                     /* if the neighbor is added, then we set its level, so it is blocked */       
                     node_list[neighbor_id].level = actual_levels;} 
                }//if (neighbor is available)
                /* go to the next neighbor */
                aux_index++;              
         }//while(b_children_tot...
         
         /* after the children selection process, we determine the bandwidth to give to each of them
            according to max_min_fairness criterion */ 
         max_min_fairness_allocation(num_children, b_father, b_children_vect, b_allocated, b_notcompl);   
         
         /* Now we can assign the rate, compute the download time and schedule the event */
         
         b_children_transm = 0.0;          
         for (j=0; j<num_children; j++){
              neighbor_id = node_list[peer_id].neighbors[j];
                       
              node_list[neighbor_id].rate         = MIN(b_allocated[j], node_list[peer_id].rate);
              node_list[neighbor_id].end_chunk    = node_list[peer_id].end_chunk + 1/b_allocated[j];
              node_list[neighbor_id].end_file     = node_list[neighbor_id].end_chunk +
                                                    (chunks-1)/node_list[neighbor_id].rate;

              node_list[neighbor_id].spare_dwl_bw = node_list[neighbor_id].dwl_bw -
                                                    node_list[neighbor_id].rate;
              node_list[neighbor_id].fathers      = 1;  
              node_list[neighbor_id].stripe       = node_list[peer_id].stripe;

              /* update here the file time matrix; the result is propagate for all the rounds 
              for computational stability */ 
              for (k=rounds; k < max_rounds; k++){
                  end_file_time[k][neighbor_id] = node_list[neighbor_id].end_file;
              }
              b_children_transm += node_list[neighbor_id].rate;
              
              /* since the upload rate is determined not only by the upload rate but also by the
                 upload bandwidth, at this stage we need to explicitly take into account this 
                 fact; we do this at this stage because it influeces the children of this node, 
                 and we use it to compute its download times */
              node_list[neighbor_id].rate = MIN(node_list[neighbor_id].rate, 
                                                node_list[neighbor_id].upl_bw);
         
              /* now we can insert the event in the time_vector that keeps track of the node_id;
                 we eapand the index used to insert int he vecotr so we can mange overlapped events */ 
              aux_time_index = expansion_factor*node_list[neighbor_id].end_chunk;
              while((time_vector[aux_time_index]>=0)&&(aux_time_index<time_limit_for_chunk))
                   aux_time_index++;
              if(aux_time_index<time_limit_for_chunk)  
                   {time_vector[aux_time_index] = neighbor_id;}
              else {not_overflow = 0;}                    
         }//for j<num_children
      
      }//if((peer_id >= 0)&&...
 
      /* the previuos 'if' is done if the maximum level is not reached; the following 'if' is done 
         for every node: it is a collection of measures */
         if (peer_id >= 0) {
             /* first: a new peer is reached: register this fact */ 
             reached_peers++;
             /* second: update information related tot he node */
             node_list[peer_id].num_children = num_children; 
             node_list[peer_id].spare_upl_bw = node_list[peer_id].upl_bw - b_children_transm;
     
             /* third: update statistics related to a "level viewpoint" */
             actual_levels = node_list[peer_id].level;
             //* I do not understand the following if... sooner or later check if things wirk without it */   
             if (actual_levels >= MAX_LEVELS)  actual_levels -= MAX_LEVELS;
             reached_peers_per_level[actual_levels][NUM_PEERS]++;
             reached_peers_per_level[actual_levels][END_FILE]  += node_list[peer_id].end_file;
             reached_peers_per_level[actual_levels][END_CHUNK] += node_list[peer_id].end_chunk;
              
             /* finally: if the node is a leaf, update statistics and put the node_id in the 
                "next_round" list */
             if (num_children == 0) {
                 reached_peers_per_level[actual_levels][NUM_LEAVES]++;
                 /* as a little trick, I add to the "level" field of the structure 
                    a new value; only for secutiry purpose */
                 if(node_list[peer_id].level < MAX_LEVELS) {
                     x_round_id_list[num_peers_next_round] = peer_id;        
                     num_peers_next_round++ ;
                     node_list[peer_id].level += MAX_LEVELS;
                 }
                 /* other statistics*/           
                 b_father = node_list[peer_id].upl_bw;                
                 for (j=0; j<num_deltas_pmf; j++){
                     if ((int)(b_father*bw_normalization) == (int)base_chunk_vect[1][j]){
                         num_leaves[j] += 1/(double)max_iterations;
                     }//if
                 }//for j
             }//if(num_children == 0)  
             if (b_children_transm < b_father) 
                 spare_bw[0] += (b_father - b_children_transm)/max_iterations;
          } 
      
      /* this was done if and only if at time "time_index" a node was scheduled */  
  }//while(time_index ...
  
  /***********************************************************************************/

  /* at this point we have finished the first round and the diffusion tree are built; 
     now we want to analyze the next round and the nodes that are considered for the
     next round are listed in x_round_id_list[]; as an optimization, only in this case,
     we sort the neighbors of the node listed in x_round_id_list[] such that leaf are 
     preferred; the intuition is that usually laef nodes receives less rate, so they are
     willing to receive more rate; as a future improvement, this sort can be done at
     the beginning of all the rounds with smart policies (e.g. who needs more rate) */
  
  for (i=0; i < num_peers_next_round; i++) {
         peer_id = x_round_id_list[i];
         aux_index = 0; 
         for (j=0; j < num_neighbors; j++){
             neighbor_id =  node_list[peer_id].neighbors[j];
              if ( (node_list[neighbor_id].num_children == 0) && (node_list[neighbor_id].level >= 0) ) {
                   if(j > aux_index) {
                       swap_int(node_list[peer_id].neighbors, j, aux_index); 
                    }
                   aux_index++;               
              }
         }//for j
  }//for i
  
  /***********************************************************************************/
  
  /* 
     now we start with the next rounds; in this case, the list contains only leaf nodes
     some open points:
     - if a internal node has rate r_1 and max_children children, and its bw is not 
       saturated (i.e., max_children*r_1 < node_bw), there could happen that it receives 
       new rate and it can redistribute it among its children; we do not consider this 
       case, supposing it is negligible
     - self loops (a node x that uploads to node y that in turn upload to node x) are
       avoided fixinng the number of nodes and, mainly, the stripe_id, but this aspect
       should be studied in detail 
  */
  
  for (rounds = 1; rounds < max_rounds; rounds++) {

      offset_this_round = (offset_this_round + num_peers_this_round)%max_num_peers;
      num_peers_this_round = num_peers_next_round;
      num_peers_next_round = 0;

      for (i=0; i < num_peers_this_round; i++) {
         
         peer_id = x_round_id_list[(offset_this_round + i)%max_num_peers];
         /* the bandwidth considered is the spare upload bandwidth */ 
         b_father          = node_list[peer_id].spare_upl_bw; 
         /* looking at the rate, since at the first round we have only leaf nodes, 
            the rate is the rate that they receive; in the following rounds, we consider only the
            additional rate  */ 
         if (rounds == 1)
           b_father_transm   = node_list[peer_id].rate;
         else
           b_father_transm   = node_list[peer_id].new_rate;
         b_children_tot    = 0.0;
         b_children_transm = 0.0;
         num_children      = 0;
         aux_index         = 0;
         
         father_stripe     = ((int)node_list[peer_id].stripe)>>16;    
      
         /* the children selection process is equal to the previous one, without the constraint
            on the minimum number of children */
         while (((b_children_tot < b_father) || (b_children_transm < b_father)) &&
                 (num_children<max_num_children) && (aux_index < num_neighbors)) {
                
             neighbor_id =  node_list[peer_id].neighbors[aux_index];
             neighbor_rcv_stripe = ((int)node_list[neighbor_id].stripe)&((int)(pow(2,16) - 1));    
             /* I can help my neighbor if and only if : 
                (i)   I have spare_dwl_bw; 
                (ii)  my neighbor has a number of fathers less than the number of stripes; 
                (iii) my neighbor has a different stripe.  
                (iv)  my neighbor was already involved in the distribution process (this constraints 
                      is necessary for level-bounded trees, so my node_list has node not yet reached) 
                NOTE: things work for 2 stripes and must be adapted to general number of stripes */  
             if ((node_list[neighbor_id].spare_dwl_bw > 0) && (node_list[neighbor_id].fathers<NUM_STRIPES) &&
                   ((neighbor_rcv_stripe&father_stripe)==0 ) && (node_list[neighbor_id].level >= 0)) {
                
                b_children_vect[num_children] = node_list[neighbor_id].spare_dwl_bw;    
                                
                /* sort of my neighbors so that the first neighbors will be my children */
                if (aux_index > num_children){
                    swap_int(node_list[peer_id].neighbors, num_children, aux_index);
                }
                
                b_children_tot += b_children_vect[num_children];
                b_children_transm += MIN(b_children_vect[num_children], b_father_transm);
                /* if (b_children_transm > b_father) I have to check the the father bw is sufficiently
                   used without this new children (a new children will lower the total rate). If father
                   bw is used more than 75%, then I do not add new children */
                if (b_children_transm > b_father){
                    used_bandwidth = b_children_transm - MIN(b_children_vect[num_children], b_father_transm);
                   if ((used_bandwidth/b_father<MIN_PERCENTAGE_USED_BW))
                      {num_children++;}
                }
                else {num_children++;}
             }//if... DWL_SPARE > 0
             /* go to the next neighbor */
             aux_index++;              
         }//while(b_children_tot...

         /* after the children selection process, we determine the bandwidth to give to each of them
            according to max_min_fairness criterion */ 
         max_min_fairness_allocation(num_children, b_father, b_children_vect, b_allocated, b_notcompl);   
         
         /* Now we can assign the rate, compute the download time and schedule the event;  
            we assume that the new rate has an immediate effect and it will decrease the total 
            download time, regardless of the effective absolute time the new rate start to help; 
            as a future improvement we can take into account the delay of the help, computing
            the final total download time accordingly*/
         b_children_transm = 0.0;          
         for (j=0; j<num_children; j++){
              neighbor_id = node_list[peer_id].neighbors[j];
             
              node_list[neighbor_id].new_rate    += MIN(b_allocated[j], b_father_transm);
              node_list[neighbor_id].end_file     = node_list[neighbor_id].end_chunk +
                                                    (chunks-1)/(node_list[neighbor_id].rate +
                                                                node_list[neighbor_id].new_rate);

              node_list[neighbor_id].spare_dwl_bw = node_list[neighbor_id].dwl_bw -
                                                    node_list[neighbor_id].rate - 
                                                    node_list[neighbor_id].new_rate;
              node_list[neighbor_id].fathers     += 1;  
              node_list[neighbor_id].stripe      += father_stripe;
              
              /* update here the file time matrix; the result is propagate for all the rounds 
              for computational stability */ 
              for (k=rounds; k < max_rounds; k++){
                  end_file_time[k][neighbor_id] = node_list[neighbor_id].end_file;
              }
              b_children_transm += MIN(b_allocated[j], b_father_transm);
              
              /* now we can insert the node_id in x_round_id_list[] if and only if it is not yet present
                 in such a list (remember the trick of imposing a level > max_level) and it has spare
                 upload bandwidth */ 
              if ((node_list[neighbor_id].level < MAX_LEVELS) && (node_list[neighbor_id].spare_upl_bw > 0)) { 
                  x_round_id_list[(offset_this_round + num_peers_this_round + num_peers_next_round)%max_num_peers] = neighbor_id;
                  num_peers_next_round++ ;
                  node_list[neighbor_id].level += MAX_LEVELS;                 
              }
                       
         }//for j<num_children
              
        /* at this point the peer_id was analyzed, so we can update statistics; the trick can be cancelled */
         node_list[peer_id].level        -= MAX_LEVELS;                 
         node_list[peer_id].rate         += node_list[peer_id].new_rate;
         node_list[peer_id].rate          = MIN(node_list[peer_id].rate, node_list[peer_id].upl_bw);
         node_list[peer_id].new_rate      = 0;
         node_list[peer_id].spare_upl_bw -= b_children_transm;
         node_list[peer_id].num_children += num_children;
         /* note that there is no a strict control on the number of children: potentially, a node can
            add max_num_children at each round; we condisider that this case has little impact */
                
         spare_bw[rounds] -= b_children_transm/max_iterations;
  
      }/* here the round is terminated*/
  
  }/* for(rounds...  here all the rounds are terminated*/
  
  /***********************************************************************************/
  
  /* now that we have analyzed allt he rounds, we can start with the final statistics */

  /* sort the end_file_time */
  for (k=0; k < max_rounds; k++){
  
      sort(end_file_time[k], 0, max_num_peers - 1);
      /* find the firts non-null element */ 
     for (non_null_elem=0; non_null_elem < max_num_peers; non_null_elem++){
         if (end_file_time[k][non_null_elem] != 0)
         break;
      }   
     /* update the samples */ 
     for (i=0; i < num_samples; i++){
         aux_index = end_file_samples[i][0] + non_null_elem;
         if (aux_index < max_num_peers) {
            end_file_samples[i][2*k+1] += end_file_time[k][aux_index];
            end_file_samples[i][2*k+2]++;
         }
     }//for i
  }// for k
  
  
  /* add a ppoint in the histogram of node 50 */  
  time_index =  (int)node_list[5].end_file;
  histogram_node_50[time_index]++; 
  
  /* re-initialize all the values for the next iteration */
  for (i=0; i < max_num_peers; i++){
       
      node_list[i].level        = -1;
      node_list[i].rate         = 0.0;
      node_list[i].end_chunk    = 0.0;
      node_list[i].end_file     = 0.0;
      node_list[i].num_children = 0;
      node_list[i].spare_dwl_bw = 0.0;
      node_list[i].spare_upl_bw = 0.0;
      node_list[i].new_rate     = 0.0;
      node_list[i].fathers      = 0; 
      node_list[i].stripe       = 0;
      
      /* for the neighbors, here it is sufficient to shuffle the content, i.e., we introduce 
         randomness; for other implementation, a new initialization is necessary */  
      shuffle(num_neighbors, node_list[i].neighbors, &seed);

      /* bandwidth assignation */
      rnd_value = uniform_0_1(&seed);
      extracted_dwl_bw = base_chunk_vect[1][0];
      extracted_upl_bw = base_chunk_vect[2][0];
      for (j=0; j<num_deltas_pmf-1; j++){
           if (rnd_value > base_chunk_vect[0][j]){
              extracted_dwl_bw = base_chunk_vect[1][j+1];
              extracted_upl_bw = base_chunk_vect[2][j+1];
           }//if
      }//for i
      
      node_list[i].dwl_bw = extracted_dwl_bw/bw_normalization;
      node_list[i].upl_bw = extracted_upl_bw/bw_normalization; 
  
  
      /* other initializations */ 
      x_round_id_list[i]  = -1;
          
      for (k=0; k < max_rounds; k++){
            end_file_time[k][i] = 0.0;
      }// for k
        
   }//for i
   
   /* other initializations */
   num_peers_next_round = 0;
   num_peers_this_round = 0;
   offset_this_round = 0;
   
   /* initialize also the vector that stores the 'events' */ 
   for (i=0; i < time_limit_for_chunk; i++){
       time_vector[i] = -1; 
   } 

   /* update statistics related to reached peers per level */
   for (i=0; i < MAX_LEVELS; i++){
      if(reached_peers_per_level[i][NUM_PEERS] > 0) {
         reached_peers_per_level_final[i][NUM_PEERS]  += reached_peers_per_level[i][NUM_PEERS] / max_iterations;
         reached_peers_per_level_final[i][END_FILE]   += reached_peers_per_level[i][END_FILE]  / 
                                                        (reached_peers_per_level[i][NUM_PEERS] * max_iterations);
         reached_peers_per_level_final[i][END_CHUNK]  += reached_peers_per_level[i][END_CHUNK] / 
                                                        (reached_peers_per_level[i][NUM_PEERS] * max_iterations);
         reached_peers_per_level_final[i][NUM_LEAVES] += reached_peers_per_level[i][NUM_LEAVES]/ max_iterations;
        }//if
        /* initialize the structure */       
        reached_peers_per_level[i][NUM_PEERS]  = 0.0;
        reached_peers_per_level[i][END_FILE]   = 0.0;
        reached_peers_per_level[i][END_CHUNK]  = 0.0;
        reached_peers_per_level[i][NUM_LEAVES] = 0.0;
   }
  
}/*for iterations...  */    
  
/***********************************************************************************/
/***********************************************************************************/
/* Here all the iterations are done and we start with the final statistics         */


/* we compute the elements of the histogram so that we can normalize it;
   the normaliation factor is put in the fisrt index of the vector */ 
  cumulative_peers = 0.0;
  for (i=0; i < time_limit_for_file; i++){
     cumulative_peers += histogram_node_50[i];
  }//for i 
  histogram_node_50[0] = cumulative_peers;
  
/* we create the cumulative number of peer in the 'level' viewpoint */
cumulative_peers = 0.0;
cumulative_peers2 = 0.0;
for (i=1; i < MAX_LEVELS; i++){
   cumulative_peers += reached_peers_per_level_final[i][NUM_PEERS];
   reached_peers_per_level_final[i][NUM_PEERS] = cumulative_peers;
   
   cumulative_peers2 += reached_peers_per_level_final[i][NUM_LEAVES];
   reached_peers_per_level_final[i][NUM_LEAVES] = cumulative_peers2;
}//for i


 end_CPU_time = clock();        /* Getting the CPU time elapsed at the  */
                                /* end of the simulation run.           */

/************************************************************************/
/* open and write the first output file that contains the histogram     */
/************************************************************************/

strcpy(namefileout, out_file_radix);
strcat(namefileout, "_aux.dat");
fout = fopen(namefileout, "w");

fprintf(fout,"# %d %f %f\n", 0, histogram_node_50[0], 0.0);
cumulative_peers = 0.0;
cumulative_peers2 = 0.0;
for (k=1; k<(time_limit_for_file); k++){
   if (histogram_node_50[k] > 0) {
     cumulative_peers2 += histogram_node_50[k]/histogram_node_50[0];
     fprintf(fout,"%d %f %f %f\n", k, histogram_node_50[k], histogram_node_50[k]/histogram_node_50[0], 
                                  cumulative_peers2);
    }
    cumulative_peers += k*(histogram_node_50[k]/histogram_node_50[0]);    
}//for k 

fprintf(fout,"\n\n# little check: mean of the histogram => %f\n", cumulative_peers); 

fclose(fout);

/**************************************************************************/
/* open and write the second output file that contains the sorted samples */
/**************************************************************************/

strcpy(namefileout2, out_file_radix);
strcat(namefileout2, "_n.dat");
fout = fopen(namefileout2, "w"); 

fprintf(fout,"# reached  peers: %f\n", reached_peers_per_level_final[MAX_LEVELS-1][NUM_PEERS]);
fprintf(fout,"# CPU time (sec): %.2f\n", (double)(end_CPU_time - start_CPU_time)/CLOCKS_PER_SEC);

for (i=0; i < num_samples; i++){
    fprintf(fout,"%f",end_file_samples[i][0]);
    
    for (k=0; k < max_rounds; k++){
        fprintf(fout," %f", end_file_samples[i][2*k+1]/end_file_samples[i][2*k+2]);
    }
    fprintf(fout,"\n");
}

fprintf(fout,"\n\n");
cumulative_peers = 0.0;
for (i=0; i<num_deltas_pmf; i++){
     cumulative_peers += num_leaves[i];
}//for i
fprintf(fout,"# percentage of leaves: %f\n", cumulative_peers/(reached_peers_per_level_final[MAX_LEVELS-1][NUM_PEERS]));

fprintf(fout,"# distribution of bw in leaf nodes\n");
fprintf(fout,"# bw, percentage of leaf nodes with that bw\n");


prev_bw = 0.0;
total_bw = 0.0;
for (i=0; i<num_deltas_pmf; i++){
   prev_value = (base_chunk_vect[0][i] - prev_bw)*reached_peers_per_level_final[MAX_LEVELS-1][NUM_PEERS];
   prev_bw = base_chunk_vect[0][i];        
   
   fprintf(fout,"# %f %f\n",base_chunk_vect[1][i], num_leaves[i]/prev_value );

   total_bw       += (prev_value * base_chunk_vect[1][i])/bw_normalization; 
}//for i


fprintf(fout,"\n\n# spare upload capacity after tree delivery (total / percentage)\n");
fprintf(fout,"# TOTAL  - UPLOAD: \t %f \t %f\n", spare_bw[0], spare_bw[0]/total_bw);

prev_bw = spare_bw[0];
for (i=1; i<max_rounds; i++){
   prev_bw += spare_bw[i];
   fprintf(fout,"# spare upload capacity (absolute and percentage) after %d round\n", i);
   fprintf(fout,"# TOTAL  - UPLOAD: \t %f \t %f\n", prev_bw , prev_bw/total_bw);
}//for i

cumulative_peers  = 0; 
cumulative_peers2 = 0; 
fprintf(fout,"\n\n# final checks\n");
for (i=1; i<MAX_LEVELS; i++){
    cumulative_peers = reached_peers_per_level_final[i][NUM_PEERS] - reached_peers_per_level_final[i-1][NUM_PEERS];          
    if (cumulative_peers > 0)
       { cumulative_peers2 = reached_peers_per_level_final[i][NUM_LEAVES] - reached_peers_per_level_final[i-1][NUM_LEAVES];
         cumulative_peers2 /= cumulative_peers; 
         fprintf(fout,"# Level: %d \t Peers: %f \t percentage of leaves: %f \n", i , cumulative_peers, cumulative_peers2); 
       }
}//for i

for (i=1; i<MAX_LEVELS; i++){
    cumulative_peers = reached_peers_per_level_final[i][NUM_PEERS] - reached_peers_per_level_final[i-1][NUM_PEERS];          
    if (cumulative_peers > 0)
       { fprintf(fout,"# %f %f\n", reached_peers_per_level_final[i][NUM_PEERS],
                                   reached_peers_per_level_final[i][END_FILE] ); 
       }
}//for i
  
fclose(fout);

/**************************************************************************/
/* end of file out processing                                             */
/**************************************************************************/

 return(0);
}

